Rkns.ResourceList = {};

Rkns.ResourceList.Bin = Rkns.Utils.inherit(Rkns._BaseBin);

Rkns.ResourceList.Bin.prototype.resultTemplate = Rkns._.template(
    '<li class="Rk-Bin-Item Rk-ResourceList-Item" draggable="true" data-uri="<%-url%>" '
    + 'data-title="<%-title%>" data-description="<%-description%>" '
    + '<% if (image) { %>data-image="<%- Rkns.Utils.getFullURL(image) %>"<% } else { %>data-image=""<% } %> >'
    + '<% if (image) { %><img class="Rk-ResourceList-Image" src="<%-image%>"/><% } %><h4 class="Rk-ResourceList-Title">'
    + '<% if (url) { %><a href="<%-url%>" target="_blank"><% } %><%=htitle%><% if (url) { %></a><% } %></h4>'
    + '<% if (description) { %><p class="Rk-ResourceList-Description"><%=hdescription%></p><% } %><% if (image) { %><div style="clear: both;"></div><% } %></li>'
);

Rkns.ResourceList.Bin.prototype._init = function(_renkan, _opts) {
	this.renkan = _renkan;
    this.title_$.html(_opts.title);
    if (_opts.list) {
    	this.data = _opts.list;
    }
    this.refresh();
}

Rkns.ResourceList.Bin.prototype.render = function(searchstr) {
    if (searchstr) {
    	var _rgxp = new RegExp('('+(searchstr).replace(/(\W)/g,'\\$1')+')','gi'),
    		rxtest = new RegExp(searchstr.replace(/(\W)/g,'\\$1'),'i');
    }
    function highlight(_text) {
    	if (searchstr) {
    		return _text.replace(_rgxp, "<span class='searchmatch'>$1</span>");
    	} else {
    		return _text;
    	}
    }
    var _html = "",
        _this = this,
        count = 0;
    Rkns._(this.data).each(function(_item) {
    	if (typeof _item === "string") {
    		if (/^(https?:\/\/|www)/.test(_item)) {
    			var _element = { url: _item }
    		} else {
    			var _element = { title: _item.replace(/[:,]?\s?(https?:\/\/|www)[\d\w\/.&?=#%-_]+\s?/,'').trim() },
    				_match = _item.match(/(https?:\/\/|www)[\d\w\/.&?=#%-_]+/);
				if (_match) {
					_element.url = _match[0];
				}
				if (_element.title.length > 80) {
					_element.description = _element.title;
					_element.title = _element.title.replace(/^(.{30,60})\s.+$/,'$1…');
				}
    		}
    	} else {
    		var _element = _item;
    	}
        var title = _element.title || (_element.url || "").replace(/^https?:\/\/(www\.)?/,'').replace(/^(.{40}).+$/,'$1…'),
            url = _element.url || "",
            description = _element.description || "",
            image = _element.image || "";
        if (url && !/^https?:\/\//.test(url)) {
        	url = 'http://' + url;
        }
        if (searchstr && !rxtest.test(title) && !rxtest.test(description)) {
            return;
        }
        count++;
        _html += _this.resultTemplate({
            url: url,
            title: title,
            htitle: highlight(title),
            image: image,
            description: description,
            hdescription: highlight(description),
            static_url: _this.renkan.options.static_url
        });
    });
    _this.main_$.html(_html);
    if (searchstr && count) {
        this.count_$.text(count).show();
    } else {
        this.count_$.hide();
    }
    if (searchstr && !count) {
        this.$.hide();
    } else {
        this.$.show();
    }
    this.renkan.resizeBins();
}
    
Rkns.ResourceList.Bin.prototype.refresh = function() {
    if (this.data) {
    	this.render();
    }
}